<?

// require the Oauth component
//require Kohana::find_file('vendor','oauth');


class Twitter_user_Model extends Model {
    
    public $access_key;
    public $secret_key;
    
    public $username;
    
    public $consumer = Null;
    
    public function __construct()
    {
        parent::__construct();
        
        $this->sess = Session::instance();
    }
    
    public function set_keys($access_key,$secret_key)
    {
        $this->access_key = $access_key;
        $this->secret_key = $secret_key;
        $this->consumer = new OAuthConsumer($access_key,$secret_key);
    }
        
    public function set_username($username)
    {
        $this->username = $username;
    }
        
    public function set_session($session='twitter_oauth',$encrypt=True)
    {
        if($this->access_key && $this->secret_key)
        {
            $this->sess->set($session,$encrypt ? $this->username.'.'.sha1($this->access_key.$this->secret_key) : array($this->access_key,$this->secret_key));
        }
        

    }

    public function store_tokens()
    {
        if($this->access_key && $this->secret_key && $this->username)
        {
            $r = $this->db->getwhere(Kohana::config('twitter.database_table'),array('user'=>$this->username));
            
            if($r->count() > 0)
            {
                $this->db->update(Kohana::config('twitter.database_table'),array('access_key'=>$this->access_key,'secret_key'=>$this->secret_key),array('user'=>$this->username));
            }
            else
            {
                $this->db->insert(Kohana::config('twitter.database_table'),array('user'=>$this->username,'access_key'=>$this->access_key,'secret_key'=>$this->secret_key));
            }
        }
        
    }
    
    public function delete_keys()
    {
        $this->db->delete(Kohana::config('twitter.database_table'),array('user'=>$this->username));
    }
    
    /*
     *  Twitter_user_Model::get_from_cookie();
     *
     *  @cookie_string: the auth cookie string ("username.sha1hash")
     *
     *  returns either a new Twitter_user_Model OR Null
     */
    public static function get_from_cookie($cookie_string)
    {
        $cookie_array = explode('.',$cookie_string);
        
        if( ($user = Twitter_user_Model::retrieve_user_from_db($cookie_array[0],$cookie_array[1])) != Null)
        {
            // set the session up too so in future the session retrieves the data
            $user->set_sessions();
            return $user;
        }
        return Null;
    }
     
    /*
     *  Twitter_user_Model::get_from_session();
     *
     *  @session_tokens: the auth session string ("username.sha1hash")
     *
     *  returns either a new Twitter_user_Model OR Null
     */
    public static function get_from_session($session_tokens)
    {
        $session_array = explode('.',$session_tokens);

        if( ($user = Twitter_user_Model::retrieve_user_from_db($session_array[0],$session_array[1])) != Null)
        {
            return $user;
        }
        return Null;
    }
    
    
    public static function retrieve_user_from_db($username,$tokens_hash)
    {
        $r = Database::instance()->getwhere(Kohana::config('twitter.database_table'),array('user'=>$username));

        if($r->count() == 1)
        {
            $user = $r->current();

            // hash and compare - this is a bit hacky but it shouldnt matter too much
            // TODO: make something unique to that one cookie so you cant spoof access
            if(sha1($user->access_key.$user->secret_key) == $tokens_hash)
            {
                $user_model = new Twitter_user_Model;
                $user_model->set_username($user->user);
                $user_model->set_keys($user->access_key,$user->secret_key);
                return $user_model;
            }
        }
        return Null;
    }
}